/*
 *
 * Copyright (c) 2001
 *	Politecnico di Torino.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that: (1) source code
 * distributions retain the above copyright notice and this paragraph
 * in its entirety, (2) distributions including binary code include
 * the above copyright notice and this paragraph in its entirety in
 * the documentation or other materials provided with the
 * distribution, and (3) all advertising materials mentioning features
 * or use of this software display the following acknowledgment:
 * ``This product includes software developed by the Politecnico di Torino
 * Telecomunication Networking Group.''
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * Author:	Marco Mellia, Andrea Carpani
 * 		Telecomunication Networks Group
 * 		Politecnico di Torino
 * 		Torino, Italy
 *              http://http://www.tlc-networks.polito.it/index.html
 *		mellia@mail.tlc.polito.it
 *
 * Tstat is deeply based on TCPTRACE. The authors would like to thank
 * Shawn Ostermann for the development of TCPTRACE.
 * The original TCPTRACE copyright can be found in tcptrace.copyright file.
 *
*/


struct dhisto
{
  float min;
  float max;
  float delta;
  struct dato *dati;
};

struct dato
{
  int val;
  struct dato *next;
};

struct vhisto
{
  float min;
  float max;
  float delta;
  struct vdato *dati;
};

struct histo
{
  char *nome;
  float min;
  float max;
  float delta;
  int *dati;
};

struct histol
{
  struct histo *histop;
  struct histol *next;
};

struct adx
{
  struct in_addr ip;
  unsigned int hits;
  struct adx *next;
};

struct tp_list_elem
{
  struct tp_list_elem *next;
  struct tp_list_elem *prev;
  tcp_pair *ptp;
};

/*
struct tpp_list_elem {
	struct tpp_list_elem *next;
	struct tpp_list_elem *prev;
	struct tcp_pair *ptp;
};

struct ip_list_elem {
	struct ip_list_elem *next;
	struct ip_list_elem *prev;
	struct icp_pair *ptp;
};
*/

struct dhisto *create_dhisto (float min, float max, float delta);
struct dhisto *create_dhisto2 (float min, float max, int num_col);
int add_dhisto (struct dhisto *phisto, float val);
int print_dhisto (struct dhisto *phisto, char *titolo, char *labels);

struct histo *create_vhisto (char *formato);

struct histo *create_histo (char *nome, float min, float max, float delta);
struct histo *create_histo2 (char *nome, float min, float max, int num_col);
int print_all_histo ();
int print_histo (struct histo *phisto, char *titolo, int flag);
int print_text_histo (struct histo *phisto, char *titolo, char *labels);

int clear_all_histo ();
int clear_histo (struct histo *phisto);

int add_adx (struct in_addr *adx, struct adx *adx_index[]);
int print_adx (struct adx *adx_index[]);
int print_adx2 (struct adx *adx_index[]);

struct tp_list_elem *tplist_alloc (void);
void tplist_release (struct tp_list_elem *rel_tplist);

segment *segment_alloc (void);
void segment_release (segment *);
void segment_list_info (void);

quadrant *quadrant_alloc (void);
void quadrant_release (quadrant *);
void quadrant_list_info (void);

tcp_pair *tp_alloc (void);
void tp_release (tcp_pair * relesased_tcp_pair);

ptp_snap *ptph_alloc (void);
void ptph_release (ptp_snap * rel_ptph);
double uniform (double a, double b, long *seed);
void *MMmalloc (size_t size, const char *f_name);
