/*
 *
 * Copyright (c) 2001
 *	Politecnico di Torino.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that: (1) source code
 * distributions retain the above copyright notice and this paragraph
 * in its entirety, (2) distributions including binary code include
 * the above copyright notice and this paragraph in its entirety in
 * the documentation or other materials provided with the
 * distribution, and (3) all advertising materials mentioning features
 * or use of this software display the following acknowledgment:
 * ``This product includes software developed by the Politecnico di Torino
 * Telecomunication Networking Group.''
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * Author:	Marco Mellia, Andrea Carpani
 * 		Telecomunication Networks Group
 * 		Politecnico di Torino
 * 		Torino, Italy
 *              http://http://www.tlc-networks.polito.it/index.html
 *		mellia@mail.tlc.polito.it
 *
 * Tstat is deeply based on TCPTRACE. The authors would like to thank
 * Shawn Ostermann for the development of TCPTRACE.
 * The original TCPTRACE copyright can be found in tcptrace.copyright file.
 *
*/


/* 
 * print.c -- packet printing routines
 */

#include "tstat.h"
#include <time.h>


/* Unix format: "Fri Sep 13 00:00:00 1986\n" */
/*			   1         2          */
/*		 012345678901234567890123456789 */
char *
ts2ascii (struct timeval *ptime)
{
  static char buf[30];
  struct tm *ptm;
  char *now;
  int decimal;

  if (ZERO_TIME (ptime))
    return ("        <the epoch>       ");

  ptm = localtime (&ptime->tv_sec);
  now = asctime (ptm);

  /* splice in the microseconds */
  now[19] = '\00';
/* 	decimal = (ptime->tv_usec + 50) / 100;*//* for 4 digits */
  decimal = ptime->tv_usec;	/* for 6 digits */

  now[24] = '\00';		/* nuke the newline */
  sprintf (buf, "%s.%06d %s", now, decimal, &now[20]);

  return (buf);
}

/* same as ts2ascii, but leave the year on */
char *
ts2ascii_date (struct timeval *ptime)
{
  static char buf[30];
  struct tm *ptm;
  char *now;
  int decimal;

  if (ZERO_TIME (ptime))
    return ("        <the epoch>       ");

  ptm = localtime (&ptime->tv_sec);
  now = asctime (ptm);
  now[24] = '\00';

/* 	decimal = (ptime->tv_usec + 50) / 100;*//* for 4 digits */
  decimal = ptime->tv_usec;	/* for 6 digits */
  sprintf (buf, "%s.%06d", now, decimal);

  return (buf);
}
